#
#	NMH's Simple C Compiler, 2011--2014
#	C runtime module for OpenBSD/386
#

# Calling conventions: stack, return in %eax

	.section	.rodata
.LC0:
	.string	""

	.data
	.globl environ
	.align 4
environ:	
	.long	0

	.data
	.align 4
__progname_storage:	
	.fill 256,1,0

	.data
	.globl	__progname
	.align 4
__progname:
	.long	.LC0

	.text
	.align  4
	.globl  __start
	.globl  _start
_start:
__start:
	pushl	%ebx			# ps_strings
	pushl   %ecx                    # obj
	pushl   %edx                    # cleanup
	movl    12(%esp),%eax           # argc
	leal    20(%esp,%eax,4),%ecx    # envp
	leal    16(%esp),%edx           # argv
	pushl   %ecx
	pushl   %edx
	pushl   %eax
	call    ___start 
	# NOT REACHED

	.text
___start:
	pushl	%ebp
	movl	%esp, %ebp
	
	movl	16(%ebp), %eax	# envp
	movl	%eax, environ
	movl	%eax, Cenviron
	
	movl	12(%ebp), %eax	# argv
	movl	(%eax), %eax	# argv[0]
	pushl	%eax
	call	populate_progname
	addl	$4, %esp
	
	call	C_init
	
	movl	12(%ebp), %esi	# argv
	movl	8(%ebp), %ecx	# argc
	pushl	%ecx
	pushl	%esi
	pushl	$2		# __argc
	call	Cmain
	addl	$12,%esp
	
	pushl	%eax
	pushl	$1
x:	call	Cexit
	xorl	%ebx,%ebx
	divl	%ebx
	jmp	x

	.text
populate_progname:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$8, %esp
	cmpl	$0, 8(%ebp)
	jne	.L16
	jmp	.L15
.L16:
	subl	$8, %esp
	pushl	$47
	pushl	8(%ebp)
	call	_strrchr
	addl	$16, %esp
	movl	%eax, __progname
	cmpl	$0, __progname
	je	.L17
	incl	__progname
.L17:
	cmpl	$0, __progname
	jne	.L18
	movl	8(%ebp), %eax
	movl	%eax, __progname
.L18:
	movl	$__progname_storage, -4(%ebp)
.L19:
	movl	__progname, %eax
	cmpb	$0, (%eax)
	je	.L20
	cmpl	$__progname_storage+255, -4(%ebp)
	jb	.L22
	jmp	.L20
.L22:
	movl	-4(%ebp), %eax
	movl	%eax, %edx
	movl	__progname, %eax
	incl	__progname
	movb	(%eax), %al
	movb	%al, (%edx)
	leal	-4(%ebp), %eax
	incl	(%eax)
	jmp	.L19
.L20:
	movl	-4(%ebp), %eax
	movb	$0, (%eax)
	movl	$__progname_storage, __progname
.L15:
	leave			# ESP <- EBP, POP EBP
	ret
	
	.text
_strrchr:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$12, %esp
	movl	12(%ebp), %eax
	movb	%al, -5(%ebp)
	movl	$0, -12(%ebp)
.L25:
	movb	-5(%ebp), %al
	movl	8(%ebp), %edx
	cmpb	%al, (%edx)
	jne	.L28
	movl	8(%ebp), %eax
	movl	%eax, -12(%ebp)
.L28:
	movl	8(%ebp), %edx
	cmpb	$0, (%edx)
	jne	.L27
	movl	-12(%ebp), %eax
	movl	%eax, -4(%ebp)
	jmp	.L24
.L27:
	incl	8(%ebp)
	jmp	.L25
.L24:
	movl	-4(%ebp), %eax
	leave			# ESP <- EBP, POP EBP
	ret

	.data
	.globl	Cenviron
Cenviron:
	.long	0

# internal switch(expr) routine
# %esi = switch table, %eax = expr
	.text
	.globl	switch
switch:
	pushl	%esi
	movl	%edx,%esi
	movl	%eax,%ebx
	cld
	lodsl
	movl	%eax,%ecx
next:	lodsl
	movl	%eax,%edx
	lodsl
	cmpl	%edx,%ebx
	jnz	no
	popl	%esi
	jmp	*%eax
no:	loop	next
	lodsl
	popl	%esi
	jmp	*%eax

# int setjmp(jmp_buf env);
	.text
	.globl	Csetjmp
Csetjmp:
	movl	8(%esp),%edx
	movl	%esp,(%edx)
	addl	$4,(%edx)
	movl	%ebp,4(%edx)
	movl	(%esp),%eax
	movl	%eax,8(%edx)
	xorl	%eax,%eax
	ret

# void longjmp(jmp_buf env, int v);
	.text
	.globl	Clongjmp
Clongjmp:
	movl	8(%esp),%eax
	movl	12(%esp),%edx
	movl	(%edx),%esp
	movl	4(%edx),%ebp
	movl	8(%edx),%edx
	jmp	*%edx

# void _exit(int rc);
	.text
	.globl	C_exit
C_exit:
	pushl	8(%esp)
	call	_exit
	addl	$4,%esp
	ret

# int _sbrk(int size);
	.text
	.globl	C_sbrk
C_sbrk:
	pushl	8(%esp)
	call	sbrk
	addl	$4,%esp
	ret

# int _write(int fd, void *buf, int len);
	.text
	.globl	C_write
C_write:
	pushl	8(%esp)
	pushl	16(%esp)
	pushl	24(%esp)
	call	write
	addl	$12,%esp
	ret

# int _read(int fd, void *buf, int len);
	.text
	.globl	C_read
C_read:
	pushl	8(%esp)
	pushl	16(%esp)
	pushl	24(%esp)
	call	read
	addl	$12,%esp
	ret

# int _lseek(int fd, int pos, int how);
	.text
	.globl	C_lseek
C_lseek:
	pushl	8(%esp)
	movl	16(%esp),%eax
	cdq
	pushl	%edx		# off_t, high word
	pushl	%eax		# off_t, low word
	pushl	28(%esp)
	call	lseek
	addl	$16,%esp
	ret

# int _creat(char *path, int mode);
	.text
	.globl	C_creat
C_creat:
	pushl	8(%esp)
	pushl	16(%esp)
	call	creat
	addl	$8,%esp
	ret

# int _open(char *path, int flags);
	.text
	.globl	C_open
C_open:
	pushl	8(%esp)
	pushl	16(%esp)
	call	open
	addl	$8,%esp
	ret

# int _close(int fd);
	.text
	.globl	C_close
C_close:
	pushl	8(%esp)
	call	close
	addl	$4,%esp
	ret

# int _unlink(char *path);
	.text
	.globl	C_unlink
C_unlink:
	pushl	8(%esp)
	call	unlink
	addl	$4,%esp
	ret

# int _rename(char *old, char *new);
	.text
	.globl	C_rename
C_rename:
	pushl	8(%esp)
	pushl	16(%esp)
	call	rename
	addl	$8,%esp
	ret

# int _fork(void);
	.text
	.globl	C_fork
C_fork:
	call	fork
	ret

# int _wait(int *rc);
	.text
	.globl	C_wait
C_wait:
	pushl	8(%esp)
	call	wait
	addl	$4,%esp
	ret

# int _execve(char *path, char *argv[], char *envp[]);
	.text
	.globl	C_execve
C_execve:
	pushl	8(%esp)
	pushl	16(%esp)
	pushl	24(%esp)
	call	execve
	addl	$12,%esp
	ret

# int _time(void);
	.text
	.globl	C_time
C_time:
	pushl	$0
	call	time
	addl	$4,%esp
	ret

# int raise(int sig);
	.text
	.globl	Craise
Craise:
	call	getpid
	pushl	8(%esp)
	pushl	%eax
	call	kill
	addl	$8,%esp
	ret

# int signal(int sig, int (*fn)());
	.text
	.globl	Csignal
Csignal:
	pushl	8(%esp)
	pushl	16(%esp)
	call	signal
	addl	$8,%esp
	ret
